"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.POSITIONS = exports.EuiPopoverArrow = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _popover_arrow = require("./_popover_arrow.styles");

var _services = require("../../../services");

var _react2 = require("@emotion/react");

var _excluded = ["children", "position"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var POSITIONS = ['top', 'left', 'right', 'bottom'];
exports.POSITIONS = POSITIONS;

var EuiPopoverArrow = function EuiPopoverArrow(_ref) {
  var children = _ref.children,
      position = _ref.position,
      rest = _objectWithoutProperties(_ref, _excluded);

  var euiTheme = (0, _services.useEuiTheme)();
  var styles = (0, _popover_arrow.euiPopoverArrowStyles)(euiTheme);
  var cssStyles = [styles.euiPopoverArrow, styles[position]];
  return (0, _react2.jsx)("div", _extends({
    className: "euiPopover__arrow",
    "data-popover-arrow": position,
    css: cssStyles
  }, rest), children);
};

exports.EuiPopoverArrow = EuiPopoverArrow;
EuiPopoverArrow.propTypes = {
  className: _propTypes.default.string,
  "aria-label": _propTypes.default.string,
  "data-test-subj": _propTypes.default.string,
  css: _propTypes.default.any,
  position: _propTypes.default.any.isRequired
};