"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SIZES = exports.EuiNotificationBadge = exports.COLORS = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _services = require("../../../services");

var _badge_notification = require("./badge_notification.styles");

var _react2 = require("@emotion/react");

var _excluded = ["children", "className", "size", "color"];
var COLORS = ['accent', 'subdued'];
exports.COLORS = COLORS;
var SIZES = ['s', 'm'];
exports.SIZES = SIZES;

var EuiNotificationBadge = function EuiNotificationBadge(_ref) {
  var children = _ref.children,
      className = _ref.className,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 's' : _ref$size,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'accent' : _ref$color,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var euiTheme = (0, _services.useEuiTheme)();
  var styles = (0, _badge_notification.euiNotificationBadgeStyles)(euiTheme);
  var cssStyles = [styles.euiNotificationBadge, styles[size], styles[color]];
  var classes = (0, _classnames.default)('euiNotificationBadge', className);
  return (0, _react2.jsx)("span", (0, _extends2.default)({
    css: cssStyles,
    className: classes
  }, rest), children);
};

exports.EuiNotificationBadge = EuiNotificationBadge;