"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiCodeBlockControls = void 0;

var _react = _interopRequireWildcard(require("react"));

var _services = require("../../services");

var _code_block_controls = require("./code_block_controls.styles");

var _react2 = require("@emotion/react");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
var EuiCodeBlockControls = function EuiCodeBlockControls(_ref) {
  var paddingSize = _ref.paddingSize,
      controls = _ref.controls;
  var euiTheme = (0, _services.useEuiTheme)();
  var styles = (0, _code_block_controls.euiCodeBlockControlsStyles)(euiTheme);
  var cssStyles = [styles.euiCodeBlock__controls, styles.offset[paddingSize]];
  var hasControls = controls.some(function (control) {
    return !!control;
  });
  return hasControls ? (0, _react2.jsx)("div", {
    className: "euiCodeBlock__controls",
    css: cssStyles
  }, controls.map(function (control, i) {
    return (0, _react2.jsx)(_react.Fragment, {
      key: i
    }, control);
  })) : null;
};

exports.EuiCodeBlockControls = EuiCodeBlockControls;