"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GUTTER_SIZES = exports.EuiFlexGrid = exports.DIRECTIONS = exports.ALIGN_ITEMS = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _services = require("../../services");

var _flex_grid = require("./flex_grid.styles");

var _react2 = require("@emotion/react");

var _excluded = ["children", "className", "gutterSize", "direction", "alignItems", "responsive", "columns", "component"];
var DIRECTIONS = ['row', 'column'];
exports.DIRECTIONS = DIRECTIONS;
var ALIGN_ITEMS = ['stretch', 'start', 'end', 'center', 'baseline'];
exports.ALIGN_ITEMS = ALIGN_ITEMS;
var GUTTER_SIZES = ['none', 's', 'm', 'l', 'xl'];
exports.GUTTER_SIZES = GUTTER_SIZES;

var EuiFlexGrid = function EuiFlexGrid(_ref) {
  var children = _ref.children,
      className = _ref.className,
      _ref$gutterSize = _ref.gutterSize,
      gutterSize = _ref$gutterSize === void 0 ? 'l' : _ref$gutterSize,
      _ref$direction = _ref.direction,
      direction = _ref$direction === void 0 ? 'row' : _ref$direction,
      _ref$alignItems = _ref.alignItems,
      alignItems = _ref$alignItems === void 0 ? 'stretch' : _ref$alignItems,
      _ref$responsive = _ref.responsive,
      responsive = _ref$responsive === void 0 ? true : _ref$responsive,
      _ref$columns = _ref.columns,
      columns = _ref$columns === void 0 ? 1 : _ref$columns,
      _ref$component = _ref.component,
      Component = _ref$component === void 0 ? 'div' : _ref$component,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var gridTemplateRows = direction === 'column' ? Math.ceil(_react.default.Children.count(children) / columns) : 0;
  var euiTheme = (0, _services.useEuiTheme)();
  var styles = (0, _flex_grid.euiFlexGridStyles)(euiTheme, gridTemplateRows);
  var cssStyles = [styles.euiFlexGrid, styles.gutterSizes[gutterSize], styles.direction[direction], styles.alignItems[alignItems], styles.columnCount[columns], responsive && styles.responsive];
  var classes = (0, _classnames.default)('euiFlexGrid', className);
  return (0, _react2.jsx)(Component, (0, _extends2.default)({
    css: cssStyles,
    className: classes
  }, rest), children);
};

exports.EuiFlexGrid = EuiFlexGrid;
EuiFlexGrid.propTypes = {
  className: _propTypes.default.string,
  "aria-label": _propTypes.default.string,
  "data-test-subj": _propTypes.default.string,
  css: _propTypes.default.any,

  /**
     * ReactNode to render as this component's content
     */
  children: _propTypes.default.node,

  /**
     * Number of columns. Accepts `1-4`
     */
  columns: _propTypes.default.oneOf([1, 2, 3, 4]),
  // Leave this as inline so the props table correctly parses it

  /**
     * Flex layouts default to left-right then top-down (`row`).
     * Change this prop to `column` to create a top-down then left-right display.
     */
  direction: _propTypes.default.any,

  /**
     * Aligns grid items vertically
     */
  alignItems: _propTypes.default.any,

  /**
     * Space between flex items
     */
  gutterSize: _propTypes.default.any,

  /**
     * Will display each item at full-width on smaller screens
     */
  responsive: _propTypes.default.bool,

  /**
     * The tag to render
     * @default div
     */
  component: _propTypes.default.any
};