"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._EuiPageInner = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _global_styling = require("../../../global_styling");

var _services = require("../../../services");

var _page_inner = require("./page_inner.styles");

var _react2 = require("@emotion/react");

var _excluded = ["children", "component", "panelled", "border", "paddingSize", "responsive"];

var _EuiPageInner = function _EuiPageInner(_ref) {
  var children = _ref.children,
      _ref$component = _ref.component,
      Component = _ref$component === void 0 ? 'main' : _ref$component,
      panelled = _ref.panelled,
      border = _ref.border,
      _ref$paddingSize = _ref.paddingSize,
      paddingSize = _ref$paddingSize === void 0 ? 'none' : _ref$paddingSize,
      _ref$responsive = _ref.responsive,
      responsive = _ref$responsive === void 0 ? ['xs', 's'] : _ref$responsive,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var themeContext = (0, _services.useEuiTheme)();
  var isResponding = (0, _services.useIsWithinBreakpoints)(responsive);
  var styles = (0, _page_inner.euiPageInnerStyles)(themeContext);
  var paddingStyles = (0, _global_styling.useEuiPaddingCSS)()[paddingSize];
  var borderSide;

  if (border && isResponding) {
    borderSide = 'top';
  } else if (border) {
    borderSide = 'left';
  }

  var cssStyles = [styles.euiPageInner, paddingStyles, panelled && styles.panelled, borderSide && styles.border[borderSide]];
  return (// @ts-expect-error Generic element type mismatch
    (0, _react2.jsx)(Component, (0, _extends2.default)({
      css: cssStyles
    }, rest), children)
  );
};

exports._EuiPageInner = _EuiPageInner;